# Add database adapter

Every database adapter is a separate package. To create a adapter for new database you need to create a new Dart package and the database adapter should extend `Adapter` class.

## Create package

The naming pattern for the database adapter package is `utopia_database_adapter_<database_name>`. For example, the MariaDB adapter package is `utopia_database_adapter_mariadb`.

```bash
dart create -t package utopia_database_adapter_<database_name>
```

## Add dependencies

```yaml
dependencies:
  utopia_database: <latest>
```

## Create adapter

Create a new Dart file in the `lib` directory and extend the `Adapter` class.

```dart
import 'package:utopia_database/utopia_database.dart';

class <DatabaseName> extends Adapter {
    // implement the abstract methods
}
```

> If you want the adapter to be a part of utopia-dart ecosystem, please raise a issue and share your repo URL and we will review and create a repo under utopia-dart organization.