extension DateTimeExtension on DateTime {
  /// Format date time
  String format() {
    return toString().split('.')[0];
  }

  /// Add seconds to date time
  DateTime addSeconds(int seconds) {
    var interval = Duration(seconds: seconds);
    return add(interval);
  }

  /// Format utc
  String? formatTz(String? dbFormat) {
    if (dbFormat == null) {
      return null;
    }

    try {
      return '${toUtc().toString().split('.')[0]}Z';
    } catch (e) {
      return dbFormat;
    }
  }
}
